package com.totopia.server.commons.data.entity;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.experimental.SuperBuilder;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.LastModifiedBy;

import javax.persistence.MappedSuperclass;

/**
 * Created by rajeevkumarsingh on 19/08/17.
 */

@MappedSuperclass
@JsonIgnoreProperties(value = { "createdBy", "updatedBy" }, allowGetters = true)
@SuperBuilder
public abstract class UserDateAuditEntity extends DateAuditEntity {

  private static final long serialVersionUID = 6379346917688414915L;

  @CreatedBy
  private Long createdBy;

  @LastModifiedBy
  private Long updatedBy;

  public UserDateAuditEntity(Long createdBy, Long updatedBy) {
    this.createdBy = createdBy;
    this.updatedBy = updatedBy;
  }

  public UserDateAuditEntity() {
  }

  public Long getCreatedBy() {
    return this.createdBy;
  }

  public Long getUpdatedBy() {
    return this.updatedBy;
  }

  public void setCreatedBy(Long createdBy) {
    this.createdBy = createdBy;
  }

  public void setUpdatedBy(Long updatedBy) {
    this.updatedBy = updatedBy;
  }

  public String toString() {
    return "UserDateAuditEntity(createdBy=" + this.getCreatedBy() + ", updatedBy=" + this.getUpdatedBy() + ")";
  }

  public boolean equals(final Object o) {
    if (o == this) return true;
    if (!(o instanceof UserDateAuditEntity)) return false;
    final UserDateAuditEntity other = (UserDateAuditEntity) o;
    if (!other.canEqual((Object) this)) return false;
    final Object this$createdBy = this.getCreatedBy();
    final Object other$createdBy = other.getCreatedBy();
    if (this$createdBy == null ? other$createdBy != null : !this$createdBy.equals(other$createdBy)) return false;
    final Object this$updatedBy = this.getUpdatedBy();
    final Object other$updatedBy = other.getUpdatedBy();
    if (this$updatedBy == null ? other$updatedBy != null : !this$updatedBy.equals(other$updatedBy)) return false;
    return true;
  }

  protected boolean canEqual(final Object other) {
    return other instanceof UserDateAuditEntity;
  }

  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final Object $createdBy = this.getCreatedBy();
    result = result * PRIME + ($createdBy == null ? 43 : $createdBy.hashCode());
    final Object $updatedBy = this.getUpdatedBy();
    result = result * PRIME + ($updatedBy == null ? 43 : $updatedBy.hashCode());
    return result;
  }
}
