package com.totopia.server.modules.user.entity;

import com.totopia.server.commons.data.entity.UserDateAuditEntity;
import com.totopia.server.modules.user.type.ProcessingStatus;
import lombok.*;
import lombok.experimental.SuperBuilder;

import javax.persistence.*;
import java.io.Serializable;

@Entity(name = "withdrawal")
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@Getter
@Setter
@ToString
@Data
public class WithdrawalEntity extends UserDateAuditEntity implements Serializable {
    @Id
    @GeneratedValue(generator = "withdrawal_generator")
    @SequenceGenerator(name = "withdrawal_generator", sequenceName = "withdrawal_sequence", initialValue = 1)
    private Long id;

    @Column(name = "amount_of_money", nullable = false)
    private Integer amountOfMoney;

    @Column(name = "deposit_user", nullable = false)
    private Long withdrawalUser;

    @Column(name = "confirm_user", nullable = false)
    private Long confirmUser;

    @Column(name = "bank_account", nullable = false)
    private Long bankAccount;

    @Enumerated(EnumType.STRING)
    @Column(name = "status", length = 60)
    private ProcessingStatus status;
}
