package com.totopia.server.auth.payload;

import javax.validation.constraints.NotBlank;

public class SigninRequest {
  @NotBlank
  private String username;

  @NotBlank
  private String password;

  public SigninRequest(@NotBlank String username, @NotBlank String password) {
    this.username = username;
    this.password = password;
  }

  public SigninRequest() {
  }

  public static SigninRequestBuilder builder() {
    return new SigninRequestBuilder();
  }

  public @NotBlank String getUsername() {
    return this.username;
  }

  public @NotBlank String getPassword() {
    return this.password;
  }

  public void setUsername(@NotBlank String username) {
    this.username = username;
  }

  public void setPassword(@NotBlank String password) {
    this.password = password;
  }

  public boolean equals(final Object o) {
    if (o == this) return true;
    if (!(o instanceof SigninRequest)) return false;
    final SigninRequest other = (SigninRequest) o;
    if (!other.canEqual((Object) this)) return false;
    final Object this$username = this.getUsername();
    final Object other$username = other.getUsername();
    if (this$username == null ? other$username != null : !this$username.equals(other$username)) return false;
    final Object this$password = this.getPassword();
    final Object other$password = other.getPassword();
    if (this$password == null ? other$password != null : !this$password.equals(other$password)) return false;
    return true;
  }

  protected boolean canEqual(final Object other) {
    return other instanceof SigninRequest;
  }

  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final Object $username = this.getUsername();
    result = result * PRIME + ($username == null ? 43 : $username.hashCode());
    final Object $password = this.getPassword();
    result = result * PRIME + ($password == null ? 43 : $password.hashCode());
    return result;
  }

  public String toString() {
    return "SigninRequest(username=" + this.getUsername() + ", password=" + this.getPassword() + ")";
  }

  public static class SigninRequestBuilder {
    private @NotBlank String username;
    private @NotBlank String password;

    SigninRequestBuilder() {
    }

    public SigninRequest.SigninRequestBuilder username(@NotBlank String username) {
      this.username = username;
      return this;
    }

    public SigninRequest.SigninRequestBuilder password(@NotBlank String password) {
      this.password = password;
      return this;
    }

    public SigninRequest build() {
      return new SigninRequest(username, password);
    }

    public String toString() {
      return "SigninRequest.SigninRequestBuilder(username=" + this.username + ", password=" + this.password + ")";
    }
  }
}
